{ Copyright (C) 1998-2000, written by Shkolnik Mike
  FIDOnet: 2:463/106.14
  E-Mail:  mshkolnik@scalabium.com
           mshkolnik@yahoo.com
  WEB: http://www.scalabium.com
       http://www.geocities.com/mshkolnik
  tel: 380-/44/-552-10-29

  This components allows to create a
  TButton, TCheckBox and TRadioButton with multi-line captions.
  To use drop a component on form and set a WordWrap property.
}
unit SMultiBtn;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons;

type
  TSMButton = class(TButton)
  private
    FWordWrap: Boolean;
    procedure SetWordWrap(Value: Boolean);
  protected
    procedure CreateParams(var Params: TCreateParams); override;
  public
    constructor Create(AOwner: TComponent); override;
  published
    property WordWrap: Boolean read FWordWrap write SetWordWrap default True;
  end;

  TSMCheckBox = class(TCheckBox)
  private
    FWordWrap: Boolean;
    procedure SetWordWrap(Value: Boolean);
  protected
    procedure CreateParams(var Params: TCreateParams); override;
  public
    constructor Create(AOwner: TComponent); override;
  published
    property WordWrap: Boolean read FWordWrap write SetWordWrap default True;
  end;

  TSMRadioButton = class(TRadioButton)
  private
    FWordWrap: Boolean;
    procedure SetWordWrap(Value: Boolean);
  protected
    procedure CreateParams(var Params: TCreateParams); override;
  public
    constructor Create(AOwner: TComponent); override;
  published
    property WordWrap: Boolean read FWordWrap write SetWordWrap default True;
  end;

procedure Register;

implementation

{$R SMultiBtn.Res}

constructor TSMButton.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  FWordWrap := True;
end;

procedure TSMButton.SetWordWrap(Value: Boolean);
begin
  if (FWordWrap <> Value) then
  begin
    FWordWrap := Value;
    ReCreateWnd;
  end;
end;

procedure TSMButton.CreateParams(var Params: TCreateParams);
begin
  inherited CreateParams(Params);

  if FWordWrap then
    Params.Style := Params.Style or BS_MULTILINE
  else
    Params.Style := Params.Style and not BS_MULTILINE;
end;


constructor TSMCheckBox.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  FWordWrap := True;
end;

procedure TSMCheckBox.SetWordWrap(Value: Boolean);
begin
  if (FWordWrap <> Value) then
  begin
    FWordWrap := Value;
    ReCreateWnd;
  end;
end;

procedure TSMCheckBox.CreateParams(var Params: TCreateParams);
begin
  inherited CreateParams(Params);

  if FWordWrap then
    Params.Style := Params.Style or BS_MULTILINE or BS_TOP
  else
    Params.Style := Params.Style and not BS_MULTILINE or not BS_TOP;
end;


constructor TSMRadioButton.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  FWordWrap := True;
end;

procedure TSMRadioButton.SetWordWrap(Value: Boolean);
begin
  if (FWordWrap <> Value) then
  begin
    FWordWrap := Value;
    ReCreateWnd;
  end;
end;

procedure TSMRadioButton.CreateParams(var Params: TCreateParams);
begin
  inherited CreateParams(Params);

  if FWordWrap then
    Params.Style := Params.Style or BS_MULTILINE or BS_TOP
  else
    Params.Style := Params.Style and not BS_MULTILINE or not BS_TOP;
end;

procedure Register;
begin
  RegisterComponents('SMComponents', [TSMButton, TSMCheckBox, TSMRadioButton]);
end;

end.
